Index: factory/cf_gcd_smallp.h
===================================================================
--- factory/cf_gcd_smallp.h	(revision 231b0fd0173552d615fba69018a64ff5510211be)
+++ factory/cf_gcd_smallp.h	(revision 018577ef150959aa2cb45fc6f4167e9ef1096972)
@@ -64,4 +64,39 @@
 
 CanonicalForm 
-randomIrredpoly (int i, const Variable & x) ;
+randomIrredpoly (int i, const Variable & x);
+
+CanonicalForm 
+sparseGCDFp (const CanonicalForm& F, const CanonicalForm& G,
+             bool& topLevel, CFList& l);
+             
+static inline CanonicalForm sparseGCDFp (const CanonicalForm& A, const CanonicalForm& B)
+{
+  CFList list;
+  bool top_level= true;
+  return sparseGCDFp (A, B, top_level, list);
+}
+
+CanonicalForm 
+sparseGCDFq (const CanonicalForm& F, const CanonicalForm& G, const Variable& alpha, CFList& l,
+             bool& topLevel);
+             
+static inline CanonicalForm sparseGCDFq (const CanonicalForm& A, const CanonicalForm& B, const Variable& alpha)
+{
+  CFList list;
+  bool top_level= true;
+  return sparseGCDFq (A, B, alpha, list, top_level);
+}
+
+/// Extended Zassenhaus GCD over finite fields described in "Algorithms for 
+/// Computer Algebra" by Geddes, Czapor & Labahn
+CanonicalForm EZGCD_P (const CanonicalForm& F, const CanonicalForm& G);
+
+/// pseudo remainder GCD over finite fields
+CanonicalForm
+gcd_poly_p( const CanonicalForm & f, const CanonicalForm & g);
+
+CanonicalForm
+gcd_univar_ntlp( const CanonicalForm & F, const CanonicalForm & G );
+
+
 #endif
Index: factory/cf_switches.cc
===================================================================
--- factory/cf_switches.cc	(revision 231b0fd0173552d615fba69018a64ff5510211be)
+++ factory/cf_switches.cc	(revision 018577ef150959aa2cb45fc6f4167e9ef1096972)
@@ -31,4 +31,5 @@
   On(SW_USE_NTL);
   On(SW_USE_CHINREM_GCD);
+  On(SW_USE_EZGCD_P);
   //Off(SW_USE_NTL_GCD_0);
   //Off(SW_USE_NTL_GCD_P);
@@ -36,5 +37,4 @@
 #endif
   On(SW_USE_EZGCD);
-  //On(SW_USE_EZGCD_P); // still testing
   On(SW_USE_QGCD);
   //On(SW_USE_fieldGCD);
Index: factory/facHensel.cc
===================================================================
--- factory/facHensel.cc	(revision 231b0fd0173552d615fba69018a64ff5510211be)
+++ factory/facHensel.cc	(revision 018577ef150959aa2cb45fc6f4167e9ef1096972)
@@ -924,8 +924,7 @@
 void 
 henselLift12 (const CanonicalForm& F, CFList& factors, int l, CFArray& Pi, 
-              CFList& diophant, CFMatrix& M, bool sort) 
-{
-  if (sort)
-    sortList (factors, Variable (1));
+              CFList& diophant, CFMatrix& M) 
+{
+  sortList (factors, Variable (1));
   Pi= CFArray (factors.length() - 1);
   CFListIterator j= factors;
